" Vim syntax file
" Language:     RegSTAB
" Filenames:    *.stab
" Maintainers:  Vincent Aravantinos <vincent.aravantinos@gmail.com>
" Last Change:  2009 Jul 5 - Initial version.

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax") && b:current_syntax == "regstab"
  finish
endif

" RegSTAB is case sensitive.
syn case match

"syn match regstabError "\S" 
syn match    regstabComment   "//.*"
syn keyword regstabKwd let in
syn match regstabKwd "\(:=\|,\|(\|)\)"
syn match regstabOperators "/\\\|\\/\|(+)\|<->\|->\|(\|)\|\~"
syn match regstabIdxProp "[[:upper:]][[:alpha:][:digit:]']*_\(-\?[[:digit:]]*\|[[:lower:]][[:lower:][:digit:]']*\%(\%(+\|-\)[[:digit:]]*\)\)\?"
syn match regstabFunction contains=regstabKwd "[[:upper:]][[:alpha:][:digit:]']*([^)]\{-})"
syn match regstabOperators "[[:lower:]][[:lower:][:digit:]']*=[[:digit:]]*\.\.[[:lower:]][[:lower:][:digit:]']*\%(\%(+\|-\)[[:digit:]]*\)\?"

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_regstab_syntax_inits")
  if version < 508
    let did_regstab_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink regstabError		  Error
  HiLink regstabComment  	Comment
  HiLink regstabKwd       Statement
  HiLink regstabOperators Constant

  delcommand HiLink
endif

let b:current_syntax = "regstab"
